/** SGX

The   sss    gggg x   x   
     s      g      x x    Engine
      sss   g  gg   x
         s  g   g  x x          Copyright 1995-2008.
     ssss    gggg x   x         Steven Goodwin. All Rights Reserved.
    
This version has been released under the GNU Public License v2.0.

Please see the license files for details.

File: include/sgx/core/settings/configuration.hpp

*/

#ifndef SGX_CORE_SETTINGS_CONFIGURATION_HPP
#define SGX_CORE_SETTINGS_CONFIGURATION_HPP	1

class CConfiguration {
public:
	static CConfiguration *get();

	CConfiguration();
	tINT32	getOption(const sgxString &opt, tINT32 opt_default=0);
	void	setOption(const sgxString &opt, tINT32 value);
	// Completion denies all future setOption's
	void    complete(void);

protected:
	static CConfiguration		*m_pSingleton;

	typedef sgxMap<sgxString, tINT32> sgxOptionMap;
	sgxOptionMap				m_Options;

private:
	tBOOL						m_bcomplete;
};

#endif /* SGX_CORE_SETTINGS_CONFIGURATION_HPP */
